local version = 1

if version < towerofheaven.version then
	return -- Don't load the rest of the script.
end

freeslot("sfx_tohdie")

local disappearState = "S_TOH_DEATHPARTICLE"
local currentTrans = A
for i = 1, 9 do
	local freeslotStr = disappearState + i
	freeslot(freeslotStr)
	
	local nextdisstate = _G[freeslotStr]+1
	if i == 9 then nextdisstate = S_NULL end
	
	states[_G[freeslotStr]] = {
        sprite = SPR_THOK,
        frame = currentTrans,
        tics = 3,
        nextstate = nextdisstate
	}
	
	if currentTrans == A then
		currentTrans = FF_TRANS10|A
	else
		currentTrans = $ + FF_TRANS10
	end
end

local reduceScaleBy = 8
towerofheaven.boltOfJudgement = function(player)
	local mobj = player.mo
	local mobjscale = mapobjectscale
	
	-- Copied from the explosion code, make the player spectacularly fly up.
	local upgoer = 18 * mapobjectscale * P_MobjFlip(mobj)
	if mobj.eflags & MFE_UNDERWATER then
		upgoer = (117 * upgoer) / 200
	end
	
	mobj.momz = upgoer
	
	-- Halve the current horizontal player momentum.
	mobj.momx = $/4
	mobj.momy = $/4
	
	-- Die.
	K_SpinPlayer(player)
	
	-- Smite sound...
	S_StartSound(mobj, sfx_tohdie)
	
	-- Flash... (oughhh we need a mobjthinker to set it back)
	mobj.frame = $|FF_FULLBRIGHT
	mobj.tohColorPrevious = mobj.color
	mobj.color = SKINCOLOR_WHITE
	
	mobj.tohSmitten = 3
	
	-- Ok, visuals time. Copied and pasted from Thunder Shield:
	local thunderMo = P_SpawnMobj(mobj.x, mobj.y, mobj.z, MT_THOK)
	thunderMo.target = mobj
	thunderMo.state = S_LZIO11
	thunderMo.color = SKINCOLOR_GREEN
	thunderMo.scale = mobj.scale*3 + (mobj.scale/2)

	thunderMo = P_SpawnMobj(mobj.x, mobj.y, mobj.z, MT_THOK)
	thunderMo.target = mobj
	thunderMo.state = S_LZIO21
	thunderMo.color = SKINCOLOR_BROWN
	thunderMo.scale = mobj.scale*3 + (mobj.scale/2)
	
	-- Make little thok thingies that hit the failing chum's head.
	local angle = 0
	for i = 1, 16 do
		local lilThok = P_SpawnMobj(mobj.x, mobj.y, mobj.z + 48*mobjscale, MT_THOK)
		lilThok.state = S_TOH_DEATHPARTICLE1
		lilThok.scale = mobjscale/reduceScaleBy
		lilThok.destscale = mobjscale/reduceScaleBy
		lilThok.flags = $ & (~MF_NOGRAVITY)
		lilThok.color = mobj.tohColorPrevious
		lilThok.momx = mobj.momx
		lilThok.momy = mobj.momy
		lilThok.momz = upgoer/2
		lilThok.tohDeathParticle = true
		P_Thrust(lilThok, angle, 24*mobjscale)
		angle = $ + ANGLE_22h
	end
	
	if towerofheaven.isHitFeedOn then
		HF_SendHitMessage(nil, {{player.name, player.skincolor}, {skins[mobj.skin].facemmap, player.skincolor}, player}, towerofheaven.hitFeedIcon, SKINCOLOR_GREEN)
	end
end

addHook("MobjThinker", function(mobj)
	if version < towerofheaven.version then return end
	if not mobj.tohSmitten or mobj.tohSmitten == 0 then return end
	if mobj.tohSmitten > 0 then
	
		if mobj.tohSmitten == 1 then
			if mobj.frame & FF_FULLBRIGHT then
				mobj.frame = $ & (~FF_FULLBRIGHT)
			end
			mobj.color = mobj.tohColorPrevious
			mobj.tohColorPrevious = nil
		end
		mobj.tohSmitten = $ - 1
	end

end, MT_PLAYER)

addHook("MobjThinker", function(mobj)
	if version < towerofheaven.version then return end
	if not mobj.tohDeathParticle then return end
	mobj.momz = $ + P_GetMobjGravity(mobj)*reduceScaleBy

end, MT_THOK)