local version = 1

if version < towerofheaven.version then
	return -- Don't load the rest of the script.
end

freeslot("sfx_tohyes")

towerofheaven.stayForVeryLong = TICRATE*10
towerofheaven.stayForLong = TICRATE*5
towerofheaven.stayForMedium = TICRATE*3
towerofheaven.stayForShort = TICRATE

towerofheaven.specialcondition_runItBack = false
towerofheaven.specialcondition_bigO = false

local rulesBanter = {
	{say = "This one shall be...", stayFor = towerofheaven.stayForMedium},
	{say = "You are perseverant. Then...", stayFor = towerofheaven.stayForMedium},
	{say = "How about...", stayFor = towerofheaven.stayForMedium},
	{say = "From this point onward...", stayFor = towerofheaven.stayForMedium},
	{say = "Let me see...", stayFor = towerofheaven.stayForMedium},
}

local closingOffTable = {
	{say = "May heaven grant you fortune.", stayFor = towerofheaven.stayForMedium},
	{say = "May heaven grant you... fortune?", stayFor = towerofheaven.stayForMedium},
	{say = "This should be funny.", stayFor = towerofheaven.stayForMedium},
	{say = "Have fun with this new rule.", stayFor = towerofheaven.stayForMedium},
	{say = "This should be interesting.", stayFor = towerofheaven.stayForMedium},
	{say = "This should be challenging.", stayFor = towerofheaven.stayForMedium},
}

local startMonologueGeneric = {
	{say = "Yet more racers seek to scale my tower?", stayFor = towerofheaven.stayForLong},
	{say = "If you wish to claim its rewards,\nthen make your way to the finish.", stayFor = towerofheaven.stayForLong},
	{say = "But be warned, I have no patience\nfor slow racers.", stayFor = towerofheaven.stayForLong},
	{say = "Nor for racers who disobey the\nbook of laws.", stayFor = towerofheaven.stayForLong},
	{say = "Disobey my rules, and I shall\nsmite thee.", stayFor = towerofheaven.stayForLong},
	closingOffTable[1],
}

local startMonologueFirstTime = {
	{say = "Mortals, trespassing my sacred tower?", stayFor = towerofheaven.stayForMedium},
	{say = "Very well. Then I shall test you.", stayFor = towerofheaven.stayForLong},
	{say = "Obey my rulings as I write them in the\nbook of laws.", stayFor = towerofheaven.stayForLong},
	{say = "Disobey my rules, and I shall\nsmite thee.", stayFor = towerofheaven.stayForLong},
	closingOffTable[1],
}

local startMonologueRunItBack = {
	{say = "...What's this? Back again?", stayFor = towerofheaven.stayForMedium},
	{say = "Is this a paradox? Did you break a law?", stayFor = towerofheaven.stayForLong},
	{say = "Was it a mistake?\nOr did you \"run it back\"?", stayFor = towerofheaven.stayForLong},
	{say = "This is why trifling with humans is difficult...\nNevertheless:", stayFor = towerofheaven.stayForLong},
	{say = "Obey the rules as I write them,\nor I shall smite thee.", stayFor = towerofheaven.stayForLong},
	closingOffTable[1],
}

local startMonologueEncore = {
	{say = "...So the Phantom Ruby has its\ngrip even here?", stayFor = towerofheaven.stayForLong},
	{say = "Such a strong distortion...\nI thought it to be destroyed forever.", stayFor = towerofheaven.stayForLong},
	{say = "If you wish to help me discover\nwhat is happening, then I shall test you.", stayFor = towerofheaven.stayForLong},
	{say = "Obey the rules as I declare them.\nFail to do so, and I shall smite thee.", stayFor = towerofheaven.stayForLong},
	closingOffTable[1],
}

local startMonologueBigO = {
	{say = "I know you...", stayFor = towerofheaven.stayForMedium},
	{say = "You are the person who defied space and time.\nBigO, correct?", stayFor = towerofheaven.stayForLong},
	{say = "I feel honored to have a god\namong these holy halls.", stayFor = towerofheaven.stayForLong},
	{say = "However, I shall test you just like anyone else.", stayFor = towerofheaven.stayForLong},
	{say = "Obey my rules.\nFail to do so, and I shall smite thee.", stayFor = towerofheaven.stayForLong},
	closingOffTable[1],
}

local startMonologueFreePlay = {
	{say = "A single racer, climbing my tower?", stayFor = towerofheaven.stayForMedium},
	{say = "Reminds me of long, long ago,\nwhen Eid started doing the same.", stayFor = towerofheaven.stayForLong},
	{say = "...So be it. I shall not make things easy for you.", stayFor = towerofheaven.stayForLong},
	{say = "Obey my book of laws.\nDisobey my rules, and I shall smite thee.", stayFor = towerofheaven.stayForLong},
	closingOffTable[1],
}

towerofheaven.contextResponses = {
	{ -- Record Attack, BigO easter egg.
		condition = do return modeattacking and displayplayers[0].name == "UnBigO" and not towerofheaven.specialcondition_bigO end,
		dialog = startMonologueBigO,
		post = do towerofheaven.specialcondition_bigO = true end,
	},
	{ -- Record Attack
		condition = do return modeattacking end,
		dialog = {closingOffTable[1]},
	},
	{ -- Encore.
		condition = do return encoremode end,
		dialog = startMonologueEncore,
	},
	{ -- Map restart.
		condition = do return towerofheaven.previousMap == gamemap and not towerofheaven.specialcondition_runItBack end,
		dialog = startMonologueRunItBack,
		post = do towerofheaven.specialcondition_runItBack = true end,
	},
	{ -- Free play.
		condition = do return towerofheaven.pInGame() == 1 end,
		dialog = startMonologueFreePlay,
	},
	{ -- First time playing.
		condition = do return towerofheaven.playedThisMapHowManyTimes == 1 end,
		dialog = startMonologueFirstTime,
	},
	{ -- Generic.
		condition = do return true end,
		dialog = startMonologueGeneric,
	}
}

local areHUDElementsInit = false

local currentGlobalMessageQueue = {}
local currentPlayerMessageQueue = {}

local judgeMessageGlobalObj = nil
local judgeMessageGlobalTimer = 0

local judgeMessagePlayersObj = {}
local judgeMessagePlayersTimers = {}

if not toh_messagevoffset then
	rawset(_G, "toh_messagevoffset", CV_RegisterVar(
	{
		name = "toh_messagevoffset",
		defaultvalue = "150",
		flags = CV_CALL|CV_NOINIT,
		func = function(var)
			judgeMessageGlobalObj.y = var.value
		end
	}))
end

towerofheaven.flushGlobalMessageQueue = function()	
	currentGlobalMessageQueue = {}
	judgeMessageGlobalTimer = 0
end

towerofheaven.flushPlayerMessageQueue = function(player)
	currentPlayerMessageQueue[towerofheaven.isDisplayPlayer(player)+1] = {}
	judgeMessagePlayersTimers[towerofheaven.isDisplayPlayer(player)+1] = 0
end

towerofheaven.flushPlayerMessageQueueAll = function(player)
	for i = 0, 3 do towerofheaven.flushPlayerMessageQueue(displayplayers[i]) end
end

local function deepCopy(tableToCopy)
	local newTable = {}
	
	for i = 1, #tableToCopy do
		table.insert(newTable, tableToCopy[i])
	end
	
	return newTable
end

local function deepCopyEX(thisTable, tableToCopy)
	for i = 1, #tableToCopy do
		table.insert(thisTable, tableToCopy[i])
	end
end

towerofheaven.isDisplayPlayer = function(player) -- Time Travel helpers cameo
	for i = 0, 3 do
		if displayplayers[i] ~= nil and displayplayers[i] == player then
			return i
		end
	end
	
	return -1
end

local function getGlobalOrPlayerMessageObject(player, doFlush)
	doFlush = $ or true
	local localPlayer = towerofheaven.isDisplayPlayer(player)
	
	if splitscreen > 0 and localPlayer ~= -1 then
		if doFlush then towerofheaven.flushPlayerMessageQueue(localPlayer) end
		return currentPlayerMessageQueue[localPlayer+1]
	end
	
	if doFlush then towerofheaven.flushGlobalMessageQueue() end
	return currentGlobalMessageQueue
end

towerofheaven.performGodMessage = function(player, ruleNumber, description)
	-- Randomness must run for everyone...
	local randomKey = P_RandomRange(1, #rulesBanter)
	local randomKeyClosingOff = P_RandomRange(1, #closingOffTable)
	local localPlayer = towerofheaven.isDisplayPlayer(player)
	if localPlayer == -1 then return end
	
	local tableToUse = getGlobalOrPlayerMessageObject(player)
	
	table.insert(tableToUse, rulesBanter[randomKey])
	table.insert(tableToUse, {say = string.format("%i. %s", ruleNumber, description), stayFor = towerofheaven.stayForLong})
	table.insert(tableToUse, closingOffTable[randomKeyClosingOff])
end

towerofheaven.performStartMessage = function(player)
	if towerofheaven.isDisplayPlayer(player) == -1 then return end
	
	for i = 1, #towerofheaven.contextResponses do
		if towerofheaven.contextResponses[i].condition() then
			currentGlobalMessageQueue = deepCopy(towerofheaven.contextResponses[i].dialog)
			if towerofheaven.contextResponses[i].post then towerofheaven.contextResponses[i].post() end
			return
		end
	end
end

-- Hi, this is an albitrary way to allow modders to allow God to say anything.
-- Follow the dialog schemes up above to figure out how to structure god dialogue.
towerofheaven.performCustomGodMessage = function(player, message, flushMessages)
	if towerofheaven.isDisplayPlayer(player) == -1 then return end
	flushMessages = $ or true
	
	local tableToUse = getGlobalOrPlayerMessageObject(player, flushMessages)
	deepCopyEX(tableToUse, message)
end

local function processQueueLogic(queue, messageObj, timer)
	if not (queue and messageObj) then return end
	if not timer then timer = 0 end
	
	local currentMessage = queue[1]
	if not currentMessage then return end
	
	if messageObj.fullMessage ~= currentMessage.say then
		messageObj:changeText(currentMessage.say)
		S_StartSoundAtVolume(nil, sfx_tohyes, 255/(splitscreen+1), displayplayer)
	elseif timer > currentMessage.stayFor then
		local nextMessage = queue[2]
		if nextMessage == nil or (nextMessage and nextMessage.say == "") then
			messageObj:changeText("") -- Get outta here.
		else
			messageObj:changeText(nextMessage.say)
			S_StartSoundAtVolume(nil, sfx_tohyes, 255/(splitscreen+1), displayplayer)
		end
	
		table.remove(queue, 1)
		timer = 0
	else
		timer = $ + 1
	end
	
	return timer
end

local function removeMessageObjs()
	judgeMessageGlobalObj = nil
	judgeMessageGlobalTimer = 0

	judgeMessagePlayersObj = {}
	judgeMessagePlayersTimers = {}
	
	towerofheaven.flushGlobalMessageQueue()
	towerofheaven.flushPlayerMessageQueueAll()
	
	areHUDElementsInit = false
end

local function initMessageObjs(v)
	local posX, posY, flags = 160, 150, 0
	judgeMessageGlobalObj = towerofheaven.initToHString(v, "", posX, posY, "center", "center", flags, FRACUNIT)
	judgeMessageGlobalObj.lastChangedMsgTic = -towerofheaven.animTime
	
	for i = 1, 4 do
		-- **TECHNICALLY** I don't need to set the flags here just yet, I can just do that in processMessageObjs.
		local newObject = towerofheaven.initToHString(v, "", posX, posY, "center", "center", flags, FRACUNIT)
		newObject.lastChangedMsgTic = -towerofheaven.animTime
		table.insert(judgeMessagePlayersObj, newObject)
	end
	
	areHUDElementsInit = true
end

local function processMessageObjs(v)
	-- Failsafe because Diggle somehow consistently made this break
	-- with his ZB config lol
	if not areHUDElementsInit then initMessageObjs(v) end

	-- Process the global message for 1P / all players.
	judgeMessageGlobalObj:performDisplayLogic()
	
	-- Process the messages for each player
	if splitscreen > 0 then
		for i = 1, splitscreen+1 do
			judgeMessagePlayersObj[i]:performDisplayLogic()
		end
	end
end

local function splitscreenChange()
	if not judgeMessageGlobalObj then return end

	-- Process the messages for each player
	if splitscreen > 0 then
		judgeMessageGlobalObj.y = 100
	
		for i = 1, splitscreen+1 do
			if not judgeMessagePlayersObj[i] then continue end
			local posX, posY, thisPlayerFlags, vAlign, hAlign, scale = towerofheaven.getSplitscreenPosFlagsAlignsScale(displayplayers[i-1])
			judgeMessagePlayersObj[i].x = posX
			judgeMessagePlayersObj[i].y = posY
			judgeMessagePlayersObj[i].flags = thisPlayerFlags
			judgeMessagePlayersObj[i].alignV = vAlign
			judgeMessagePlayersObj[i].alignH = hAlign
			judgeMessagePlayersObj[i].scale = scale
		end
	else
		judgeMessageGlobalObj.y = toh_messagevoffset.value
	end
end

local isSplitscreenHookLoaded = false
hud.add(function(v, player, cam)
	if version < towerofheaven.version then return end
	if not towerofheaven.towerOfHeavenActive then return end
	if leveltime < 3 then return end
	
	if not areHUDElementsInit then
		initMessageObjs(v)
		if not isSplitscreenHookLoaded then
			towerofheaven.addSplitscreenHook(splitscreenChange)
			isSplitscreenHookLoaded = true
		end
	end
	
	processMessageObjs(v)
end)

addHook("ThinkFrame", function()
	if version < towerofheaven.version then return end
	if not towerofheaven.towerOfHeavenActive then return end
	if leveltime < 3 then return end
	if leveltime == 3 then removeMessageObjs() end

	judgeMessageGlobalTimer = processQueueLogic(currentGlobalMessageQueue, judgeMessageGlobalObj, judgeMessageGlobalTimer)
	if splitscreen > 0 then
		for i = 1, splitscreen+1 do
			judgeMessagePlayersTimers[i] = processQueueLogic(currentPlayerMessageQueue[i], judgeMessagePlayersObj[i], judgeMessagePlayersTimers[i])
		end
	end
end)

addHook("NetVars", function(network)
	if version < towerofheaven.version then return end
	towerofheaven.specialcondition_runItBack = network($)
	towerofheaven.specialcondition_bigO = network($)
end)