local version = 1

if version < towerofheaven.version then
	return -- Don't load the rest of the script.
end

towerofheaven.getSplitscreenPosFlagsAlignsScale = function(player)
	local flags = 0
	local x, y = 0, 0
	local vAlign, hAlign = "center", "center"
	local scale = FRACUNIT
	
	if splitscreen > 1 then -- P1, P2, P3, P4
		scale = (FRACUNIT/4)*3
		for i = 0, 3 do
			if player == displayplayers[i] then
				if i % 2 == 0 then -- odd, p1 and p3
					x = 10
					flags = $|V_SNAPTOLEFT
					hAlign = "left"
				else -- even, p2 and p4
					x = 310
					flags = $|V_SNAPTORIGHT
					hAlign = "right"
				end
				
				if i > 1 then -- even, p2 and p4
					y = 90
					flags = $|V_SPLITSCREEN
					vAlign = "bottom"
				else
					y = 90
					flags = $|V_SNAPTOTOP
					vAlign = "bottom"
				end
				
				return x, y, flags, vAlign, hAlign, scale
			end
		end
	else
		if splitscreen == 1 then -- 2P
			if player == displayplayers[0] then -- P1
				x, y = 160, 5
				flags = $|V_SNAPTOTOP
				vAlign = "top"
			else -- P2
				x, y = 160, 195
				flags = $|V_SNAPTOBOTTOM
				vAlign = "bottom"
			end
		else
			x, y = 160, 150 -- Probably should never end up here.
			flags = V_SNAPTOTOP
			vAlign = "center"
		end
	end

	return x, y, flags, vAlign, hAlign, scale
end

local splitscreenHooks = {}
local function processSplitscreenHooks()
	for i = 1, #splitscreenHooks do
		splitscreenHooks[i]()
	end
end

towerofheaven.addSplitscreenHook = function(func)
	table.insert(splitscreenHooks, func)
end

local prevSplitscreen = -1
local function detectSplitscreenChange()
	-- Always run splitscreen change hooks on level start.
	if splitscreen ~= prevSplitscreen or leveltime == 4 then
		processSplitscreenHooks()
	end
	
	prevSplitscreen = splitscreen

	return false
end

addHook("ThinkFrame", do
	if version < towerofheaven.version then return end
	if leveltime < 4 then return end
	if not towerofheaven.towerOfHeavenActive then return end
	detectSplitscreenChange()
end)